//=====================================================================
//	      .
//=====================================================================

//---------------------------------------------------------------------
#property copyright 	"Dima S."
#property link      	"dimascub@mail.com"
#property version   	"1.00"
#property description "      "
#property description "=   ="
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	 :
//---------------------------------------------------------------------
#include <Trade\Trade.mqh>
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
input double   Lots=0.1;
//---------------------------------------------------------------------
input int      MA1Period = 200;
input int      MA2Period = 50;
input int      MA3Period = 21;

//---------------------------------------------------------------------
int   max_ma_period=0;
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
int  OnInit()
  {
//	    :
   max_ma_period=MA1Period;
   if(MA2Period>max_ma_period)
     {
      max_ma_period=MA2Period;
     }
   if(MA3Period>max_ma_period)
     {
      max_ma_period=MA3Period;
     }

   return(0);
  }
//---------------------------------------------------------------------
//	  -:
//---------------------------------------------------------------------
void  OnDeinit(const int _reason)
  {
  }

//---------------------------------------------------------------------
//	        :
//---------------------------------------------------------------------
int      current_signal=0;
int      prev_signal=0;
bool   is_first_signal=true;
static datetime   chart_last_bar_datetime=0;
//---------------------------------------------------------------------
void  OnTick()
  {
//	   :
   if(CheakNewBar(Symbol(),Period(),chart_last_bar_datetime)!=1)
     {
      return;
     }

//	   / :
   current_signal=GetSignal();
   if(is_first_signal==true)
     {
      prev_signal=current_signal;
      is_first_signal=false;
     }

//	    :
   if(PositionSelect(Symbol())==true)
     {
      //	,      :
      if(CheakPositionClose(current_signal)==1)
        {
         return;
        }
     }

//	    BUY:
   if(CheckBuySignal(current_signal,prev_signal)==1)
     {
      CTrade   trade;
      trade.PositionOpen(Symbol(),ORDER_TYPE_BUY,Lots,SymbolInfoDouble(Symbol(),SYMBOL_ASK),0,0);
     }

//	    SELL:
   if(CheckSellSignal(current_signal,prev_signal)==1)
     {
      CTrade   trade;
      trade.PositionOpen(Symbol(),ORDER_TYPE_SELL,Lots,SymbolInfoDouble(Symbol(),SYMBOL_BID),0,0);
     }

//	  :
   prev_signal=current_signal;
  }
//---------------------------------------------------------------------
//	      :
//---------------------------------------------------------------------
double  OnTester()
  {
  double  param = 0.0;

//  Balance max + min Drawdown + Trades Number:
  double  balance = TesterStatistics(STAT_PROFIT);
  double  min_dd = TesterStatistics(STAT_BALANCE_DD);
  if(min_dd > 0.0)
  {
    min_dd = 1.0 / min_dd;
  }
  double  trades_number = TesterStatistics(STAT_TRADES);
  param = balance * min_dd * trades_number;

  return(param);
  }
//---------------------------------------------------------------------
//	,     :
//---------------------------------------------------------------------
//	:
//		0 -   ;
//		1 -      ;
//---------------------------------------------------------------------
int  CheakPositionClose(int _signal)
  {
   long      position_type=PositionGetInteger(POSITION_TYPE);

   if(_signal==1)
     {
      //	    BUY,  :
      if(position_type==(long)POSITION_TYPE_BUY)
        {
         return(1);
        }
     }

   if(_signal==-1)
     {
      //	    SELL,  :
      if(position_type==(long)POSITION_TYPE_SELL)
        {
         return(1);
        }
     }

//	 :
   CTrade   trade;
   trade.PositionClose(Symbol(),10);

   return(0);
  }
//---------------------------------------------------------------------
//	    BUY:
//---------------------------------------------------------------------
//	:
//		0 -  ;
//		1 -    BUY;
//---------------------------------------------------------------------
int  CheckBuySignal(int _curr_signal,int _prev_signal)
  {
//	,       BUY:
   if(( _curr_signal==1 && _prev_signal==0) || (_curr_signal==1 && _prev_signal==-1))
     {
      return(1);
     }

   return(0);
  }
//---------------------------------------------------------------------
//	    SELL:
//---------------------------------------------------------------------
//	:
//		0 -  ;
//		1 -    SELL;
//---------------------------------------------------------------------
int  CheckSellSignal(int _curr_signal,int _prev_signal)
  {
//	,       SELL:
   if(( _curr_signal==-1 && _prev_signal==0) || (_curr_signal==-1 && _prev_signal==1))
     {
      return(1);
     }

   return(0);
  }
//---------------------------------------------------------------------
//	   / :
//---------------------------------------------------------------------
int  GetSignal()
  {
   double   current_rates[];

   ResetLastError();
   if(CopyClose(Symbol(),Period(),0,max_ma_period,current_rates)!=max_ma_period)
     {
      Print("  CopyRates,  = ",GetLastError());
      return(0);
     }

//	    :
   return(TrendDetector(0,current_rates));
  }
//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
//	:
//		-1 -  ;
//		+1 -  ;
//		 0 -   ;
//---------------------------------------------------------------------
int  TrendDetector(int _shift,const double &_price[])
  {
   double   current_ma1,current_ma2,current_ma3;
   int         trend_direction=0;

   current_ma1 = GetSimpleMA( max_ma_period, MA1Period, _price );
   current_ma2 = GetSimpleMA( max_ma_period, MA2Period, _price );
   current_ma3 = GetSimpleMA( max_ma_period, MA3Period, _price );

   if(current_ma3>current_ma2 && current_ma2>current_ma1)
     {
      trend_direction=1;
     }
   else if(current_ma3<current_ma2 && current_ma2<current_ma1)
     {
      trend_direction=-1;
     }

   return(trend_direction);
  }
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
double  GetSimpleMA(const int size,const int period,const double &price[])
  {
   double   result=0.0;

   for(int i=size-1; i>=size-period; i--)
     {
      result+=price[i];
     }
   result/=(( double)period);

   return(result);
  }
//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
//	-   1,   	;
//---------------------------------------------------------------------
int  CheakNewBar(string _symbol,ENUM_TIMEFRAMES _period,datetime &_last_dt)
  {
//	    :
   datetime   curr_time=(datetime)SeriesInfoInteger(_symbol,_period,SERIES_LASTBAR_DATE);
   if(curr_time>_last_dt)
     {
      _last_dt=curr_time;
      return(1);
     }

   return(0);
  }
//---------------------------------------------------------------------
